# 14.08.2016

# T Aykanat, M Lindqvist, V L Pritchard, and C R Primmer (2016) "From population genomics to conservation and management: a workflow for targeted analysis of markers identified using genome-wide approaches in Atlantic salmon (Salmo salar)."
# e-mail: Tutku Aykanat  tutku.aykanat@utu.fi.

# SUPPLEMNETARY CODE

# This code provides functions to asses unspecific bindings in the multiplex reaction.

load("SET_FINAL") #this is to provide reverse and forward infromation


## A) FIGURE TO INVESTIGAE PER LOCUS TOPOGRPGY OF COVERAGE
## B) UNSPECIFIC / CROSS PRIMER AMPLIFICATIONS

## A) FIGURE TO INVESTIGAE PER LOCUS TOPOGRPGY OF COVERAGE
{
     ## below objects are from "Aykanat et al 2016 JFB main code 040916" line 477-478.
     ## it contains info on coverage numbers of each of teh alternative allele.
     ## note that this is after correcting for MVN structure etc..
     ## please use "COVS1" object in "Aykanat et al 2016 JFB main code 040916" at line 252 and modify code for raw calculations .
     ## note taht coverage info is ignored for sdy loci, which had no alternative allale.
     
     GENCALL1cov[1:10,1:10]
     GENCALL2cov[1:10,1:10] 
     GENCALLnumbers[1:10,1:10] ## this is for colors
     MVNlike = ifelse(SET_FINAL$MVNlike==0, "no MVN", "MVN" )
     
     #simple image example (of 10th loci which is SET_FINAL[10])
     plot(GENCALL1cov[10,], GENCALL2cov[10,], pch=20)
     abline(0,1) # this is expected heterzygot line
     
     # plotting all allales in a pdf file

     pdf(file = "genotypesV1%03d.pdf" , paper= "a4", width = 7, height = 11)
     #plot(1,1)
     par(mfrow=c(7,4),mar=c(2,2,1,1))  
     for (i in (1: 197 ) ) { print(i)
          
          MX = max(c(GENCALL1cov[i,],GENCALL1cov[i,]))
          
               COL1 = GENCALLnumbers[i,]
               COL1 [which(COL1==-9)] = "black" # this uncalled for failing criteria to call between genotypes
               COL1 [is.na(COL1)] = "dark gray"  # this uncalled due to low coverage
               COL1 [which(COL1==0)]="blue" 
               COL1 [which(COL1==1)]="purple" 
               COL1 [which(COL1==2)]="red" 
          
          if(i == 6 ) { plot(1,1, main = "this is SDY") } else {  
          
          plot( GENCALL1cov[i,] , GENCALL2cov [i,]  ,col=COL1 ,  pch= 1, xlim=c(0,MX), ylim=c(0,MX) ,
               cex=0.6, cex.axis=0.7 , main = paste(SET_FINAL[i,2],",", SET_FINAL[i,3],",", MVNlike [i]), cex.main = 0.6, ylab=NA,xlab=NA)
               # if you re-adjust thersholds in teh main code when calling genotypes, please adjust them accordingly here as well.
               if (MVNlike [i] != "no MVN")  { abline(0 ,0.1 , lty=3,col="blue");abline(0,0.2,lty=3,col="purple" );abline(0,5,lty=3,col="purple");abline(0,10,lty=3, col="blue" );abline(10,-1,lty=1,lwd=2);abline(0,1,lwd=2,col="purple") } else {abline(0,0.067 ,lty=3,col="blue");abline(0,0.25,lty=3,col="purple");abline(0,4,lty=3,col="purple");abline(0,12.5,lty=3,col="blue");abline(20,-1,lty=1,lwd=2);abline(0,1,lwd=2,col="purple") } 
          }
          }
                    
     dev.off()

     ## colors indicate called genotyped in "Aykanat et al 2016 JFB main code 040916". inspect the figure by eye if you are genotyping a diffrenet population, or if you are adding new pimers here.

}
## A) ENDS


library(Biostrings)
library(snow)

## B) UNSPECIFIC/ CROSS PRIMER AMPLIFICATIONS
## NOTE THAT UNSPECIFIC COVERAGES WERE CALCULATED A BIT DIFFERNET THEREFORE DIAGINAL OF TEH MATRIX CAN BE A BIT DIFFERNET FROM SOPEC. COVS 
{

# as the searxch criteria, we combined the forward and reverse tags, adn take only first 10 bp of primers to allow for primer-primer dimers taht will have inperfect complementary sequence
# note that the ramianing, unexplored unspecific bindings can be searched by seraching sequences in the raw data file. 
# the "ACGACGTTGTAAAA"  and "CATTAAGTTCCCATTA" are forward and reverse tags that were added in PCR-2. We use them to increase specificity of sequence.
FWDsml = paste( "ACGACGTTGTAAAA" , substr(SET_FINAL[,4],1,10) , sep = "" )
REVsml = paste ( substr( SET_FINAL[,7], nchar(SET_FINAL[,7])-11,nchar(SET_FINAL[,7])) , as.character ( reverseComplement ( DNAString ("CATTAAGTTCCCATTA") ) ) , sep="")



# this is teh list object where the sequences were stored individual by individual. (i.e. MODULE2 in "Aykanat et al 2016 JFB main code 040916.R")
load("listSeq3")

# for the purpose finding out unspecific coverage quantuty one can combine all the read into one file. this will be a bit easy to code, but may be slower due to high number of reads to scan.
# note that unspecifics are produced during teh PCR stage but detectded in the iontorrent platform, so SNPs in differenet panels can be anlaysied seperetely to reduce run timing.
# note that also that we only accounted for unsopecifics that are visible in teh iontorrent sequencing that have complementary reverse and forward barcodes (they will have complementary F and R tags). Unsoecific bidnings with non-complementary reverse and forward barcodes are expeced not be amplified in PCR-2, although they may still impair PCR-1. 
# note also that this routine takes quite a long time to execute. Better do it in the afternoon, and get teh results in teh morning (if you have strong computer and did parallelization). Perhpas you can just do it for 10 individulas, insetad of all, which will provide a good idea of proprtions. 


length(listSeq3)

cl <- makeSOCKcluster(rep("localhost",4))
	clusterExport(cl, "REVsml")
	clusterExport(cl, "FWDsml")
	clusterExport(cl, "listSeq3")

     UNSP1 = parSapply(cl,1:length(listSeq3), simplify = F ,  function (k) {    
     	   sapply ( 1:length(REVsml), function(j) { 
     	     sapply ( 1:length(FWDsml), function(i) {
     	          sum(grepl(REVsml[j] ,  listSeq3[[k]][(grepl(FWDsml[i], listSeq3[[k]] ))]))
               })
     	          })
     	 })
     	
     ## i (F)= rows, ## j (R)= column

     stopCluster(cl)
     
	## diagonals gives the specific read (this is rough estimate as it doesnt include the recognition sequence)
     ## other entries are unspecific coverage between forward (rows) and reverse (columns) primers. Note that F-F and R-R unspecifics will not be amplified by F an R tags, and they will not be persent in the iontorrent, alhough they may still impair PCR-1.
     
     sumUNSP1 = UNSP1[[1]]
     for(k in 2:length(listSeq3))  { sumUNSP1 = sumUNSP1 + UNSP1[[k]] }
     
     (sum (sumUNSP1) - sum (diag( sumUNSP1))) / sum (sumUNSP1) ## proprtion of unspecifics in the reaction.
     
     sumUNSP2 = sumUNSP1
     diag(sumUNSP2) = 0 # excluding specific coverage here
     apply( sumUNSP2 , 1 , sum) # unspecific coverage by forward primers
     apply( sumUNSP2 , 2 , sum) # unspecfic coverage by reverse primers
     
     # a non-matrix represntation fo unpscific coverages
     rownames(sumUNSP2) = SET_FINAL$id[1:40]
     colnames(sumUNSP2) = SET_FINAL$id[1:40]
     
     
     sumUNSP_tabular_pre = sapply(1: nrow(sumUNSP2), simplify=F, function(i) {
          A = sumUNSP2[i,]
          cbind( SET_FINAL$id[i] , names(A) , A)
     })
          
     sumUNSP_tabular = do.call(rbind ,sumUNSP_tabular_pre)     
     rownames(sumUNSP_tabular) = NULL
     colnames(sumUNSP_tabular) = c("Fprimer" , "Rprimer" , "unspecific coverage")
     head(sumUNSP_tabular)

     # from here than on one can inspect the intesity of unspcific coverage by eye
}
## ENDS: UNSPECIFIC/ CROSS PRIMER AMPLIFICATIONS

